function saveEmailTemplate(){
  var template = $('#select_template').val();
  var lang = $('#lang').val();
  var i=0;
  var arr_config = [];
  $(".left-sidebar input").each(function(){
    arr = [];
    arr.push($(this).attr('name'));
    arr.push($(this).val());
    arr_config.push(arr);
  });
  $(".left-sidebar textarea").each(function(){
    arr = [];
    arr.push($(this).attr('name'));
    arr.push($(this).val());
    arr_config.push(arr);
  });

  $.ajax({
    url: $('#url').val(),
    type: 'post',
    dataType: 'json',
    data: {
      type: 'saveEmailTemplate',
      folder: template,
      lang: lang,
      html: $('.demo .view').contents().find('body').html(),
      config: arr_config
    },
    complete: function(data) {
      alert(data.responseText);
    },
    error: function(data) {
      // console.log(data)
    }
  });
  // var html = $('.demo .view').contents().find('body').html();
  // console.log(html);
  return false;
}

function resetConfiguration() {
  var r = confirm("Do you want reset to dafault setting?");
  if (r == true) {
    var iframe = $('.demo .view');
      $.ajax({
        url: $('#url').val(),
        type: 'post',
        dataType: 'json',
        data: {
          type: 'resetConfiguration',
          file: $('.left-sidebar .select-template #select_template').val(),
          lang: $('.left-sidebar .select-template #lang').val()
        },
        complete: function(data) {
          window.location.replace(data.responseText);
        },
        error: function(data) {
          // console.log(data)
        }
      });
  }
}

function setValueFromHtml() {

  $(".input.text").each(function(index, el) {
    var iframe = $('.demo .view');
    var text = $(el).data('default');

    var selector = $(el).attr('name');
    var selectorCss = $('[data-'+ selector +']',iframe.contents()).data(selector);
    if(selectorCss === 'background-image'){
      text = 'url('+ text + ')';
    }

    if($(el).hasClass('text-input')){
      if($('#'+ selector,iframe.contents()).length){
        if($('#'+ selector,iframe.contents()).html() != text){
          $(el).val($('#'+ selector,iframe.contents()).html());
          $(el).data('default',$('#'+ selector,iframe.contents()).html());
        }else{
          $('#'+ selector,iframe.contents()).html(text);
        }
      }
    }else{
      if($('[data-'+ selector +']',iframe.contents()).length){
        if($(el).hasClass('font-family')){
          loadFont($(el),text);
        }
        if(selector.indexOf('image_src') !== -1){
          if (text == '') {
            $('[data-'+ selector +']',iframe.contents()).addClass('hide-block');
          }else{
            $('[data-'+ selector +']',iframe.contents()).removeClass('hide-block');
          }
        }
        $('[data-'+ selector +']',iframe.contents()).attr(selectorCss,text);
        $('[data-'+ selector +']',iframe.contents()).css(selectorCss,text);
      }
    }
    $(el).val($(el).data('default'));

  });

  $('.input.radio').each(function(index, el) {
    var iframe = $('.demo .view');
    var selector = $(el).attr('name');
    var text = $(el).data('default');
    if($('[data-'+ selector +']',iframe.contents()).length){
      if (text == 'checked'){
        $(el).prop('checked', true);
        $('[data-'+ selector +']',iframe.contents()).removeClass('hide-block');
      }else{
        $(el).prop('checked', false);
        $('[data-'+ selector +']',iframe.contents()).addClass('hide-block');
      }
    }
  });

  $(".input.jscolor").each(function(index, el) {
    var iframe = $('.demo .view');
    var selector = $(el).attr('name');
    var color = $(el).data('default');

    var selectorColorType = $('[data-'+ selector +']',iframe.contents()).data(selector);
    if($('[data-'+ selector +']',iframe.contents()).length){
      $('[data-'+ selector +']',iframe.contents()).css(selectorColorType,color);
      el.jscolor.fromString(color);
    }
  });

  checkSidebar();
  checkResponsive();
}

function genHtml(lang,template){
  var iframe = $('.demo .view');
  $.ajax({
    url: $('#url').val(),
    type: 'post',
    dataType: 'json',
    data: {
      type: 'select_template',
      folder: template,
      lang: lang,
    },
    complete: function(data) {
      if(data){
        var $iframe = $('.demo .view');
        $iframe.ready(function() {
          html = proccess(data.responseJSON.html,data.responseJSON.settings);
          $iframe.contents().find("body").html(html.body);
          $iframe.contents().find("head").html(html.head);
          setValueFromHtml();
        });
      }
    },
    error: function(data) {
      // console.log(data)
    }
  });
}

function proccess(html,json){
  var jsonHtml = himalaya.parse(html);
  mariana.init(json);
  mariana.parseDom(jsonHtml);
  var html = mariana.parse(jsonHtml);
  return html;
}

function loadFont(input,font){
  WebFont.load({
    google: { 
      families: [font]
    },
    context: frames['my-child'],
    active: function() {
      input.removeClass('error');
      alertInput(input,'',true);
    },
    inactive: function() {
      input.addClass('error');
      alertInput(input,'Font not exist. Please try again with other font !',false)
    },
  }); 
}

function update(jscolor) {
  var iframe = $('.demo .view');
  var selector = jscolor.setIn;
  var color = jscolor.valueElement.value;
  var selectorColorType = $('[data-'+ selector +']',iframe.contents()).data(selector);

  if($('[data-'+ selector +']',iframe.contents()).length){
    $('[data-'+ selector +']',iframe.contents()).css(selectorColorType,color);
  }
}

function alertInput(element,message,type){
  var parent = element.parent();
  var alert = parent.find('.alert-content');
  if(type === true){
    parent.removeClass('error-active');
  }else{
    parent.addClass('error-active');
  }
  alert.html(message);
  setTimeout(function(){ parent.removeClass('error-active'); }, 10000);
}

function checkSidebar(){
  if($(window).width() < 1400){
    $('body').addClass('active-sidebar');
  }else{
    $('body').removeClass('active-sidebar');
  }
}

function checkResponsive(){
  var width = $(window).width();
  $('.device').removeClass('active');
  if(width < 992 && width >= 768){
    $('.device').removeClass('active');
    $('.device.tablet').addClass('active');
    $('.demo').removeClass('desktop').removeClass('mobile').addClass('tablet');
  }else if(width < 768){
    $('.device').removeClass('active');
    $('.device.mobile').addClass('active');
    $('.demo').removeClass('desktop').removeClass('tablet').addClass('mobile');
  }else{
    $('.device').removeClass('active');
    $('.device.desktop').addClass('active');
    $('.demo').removeClass('tablet').removeClass('mobile').addClass('desktop');
  }
}

$(document).ready(function() {
  var iframe = $('.demo .view');
  var template = $('#select_template').val();
  var lang = $('#lang').val();
  genHtml(lang,template);

  $('.select-template select').change(function(){
    var template = $('#select_template').val();
    var lang = $('#lang').val();
    genHtml(lang,template);
  });

  checkSidebar();
  checkResponsive();
  $('#main').height($(window).height());
  $(window).resize(function() {
    $('#main').height($(window).height());
    checkSidebar();
    checkResponsive();
  });

  $('.icon-setting,.overlay,.icon-close').click(function () {
    if($('body').hasClass('show-sidebar'))
      $('body').removeClass('show-sidebar');
    else
      $('body').addClass('show-sidebar');
  });

  $(".input.jscolor").change(function(){
    var color = $(this).val();
    var selector = $(this).data('source');
    var action = $(this).data('action');

    if($('.'+ selector,iframe.contents()).length){
      $('.'+ selector,iframe.contents()).css(action, color);
      if(selector == 'header' && action == 'background-color'){
        $('td',iframe.contents()).css('background', none);
      }
    }
    if($('#'+ selector,iframe.contents()).length){
      $('#'+ selector,iframe.contents()).css(action, color);
      if(selector == 'header' && action == 'background-color'){
        $('td',iframe.contents()).css('background', none);
      }
    }

  });
  $(".input.text").keyup(function(e){
    changeText($(this));
  });

  $(".input.text").change(function(e){
    changeText($(this));
  });

  function changeText(el){
    if(el.data('action') == 'href'){
      var href = el.val();
      var selector = el.data('source');
      var selector = '';
      if(el.attr('name') == 'group_social_facebook_link'){
        selector = '.social a:nth-child(1)';
      }
      if(el.attr('name') == 'group_social_googleplus_link'){
        selector = '.social a:nth-child(2)';
      }
      if(el.attr('name') == 'group_social_instagram_link'){
        selector = '.social a:nth-child(3)';
      }
      if(el.attr('name') == 'group_social_pinterest_link'){
        selector = '.social a:nth-child(4)';
      }
      if(el.attr('name') == 'group_social_twitter_link'){
        selector = '.social a:nth-child(5)';
      }
      if(el.attr('name') == 'group_social_youtube_link'){
        selector = '.social a:nth-child(6)';
      }
      

      $(selector,iframe.contents()).attr('href', href);
      if(href.length){
        $(selector,iframe.contents()).show();
      }else{
        $(selector,iframe.contents()).hide();
      }
      
    }else{
      var text = el.val();
      var selector = el.attr('name');
      var selectorCss = $('[data-'+ selector +']',iframe.contents()).data(selector);
      if(selectorCss === 'background-image'){
        text = 'url('+ text + ')';
      }

      if(el.hasClass('text-input')){
        if($('#'+ selector,iframe.contents()).length){
          $('#'+ selector,iframe.contents()).html(text.replace(/\n/g, "<br />"));
        }
      }else{
        if($('[data-'+ selector +']',iframe.contents()).length){
          if(el.hasClass('font-family')){
            loadFont(el,text);
            // setTimeout(function(){ loadFont(el,text); }, 500);
          }
          if(selector.indexOf('image_src') !== -1){
            if (text == '') {
              $('[data-'+ selector +']',iframe.contents()).addClass('hide-block');
            }else{
              $('[data-'+ selector +']',iframe.contents()).removeClass('hide-block');
            }
          }
          $('[data-'+ selector +']',iframe.contents()).attr(selectorCss,text);
          $('[data-'+ selector +']',iframe.contents()).css(selectorCss,text);
        }
      }
    }
  }

  $('.input.radio').change(function (){
    var selector = $(this).attr('name');

    if ($('[data-'+ selector +']',iframe.contents()).length){
      if ($(this).is(':checked')){
        $('[data-'+ selector +']',iframe.contents()).removeClass('hide-block');
      }else{
        $('[data-'+ selector +']',iframe.contents()).addClass('hide-block');
      }
    }
  });

  $('.alert-input i').click(function () {
    var parent  = $(this).parents('.content-input');
    parent.removeClass('error-active');
  });

  $('.device').click(function () {
    if($(this).hasClass('mobile')){
      $('.demo').removeClass('tablet').removeClass('desktop').addClass('mobile');
    }else if($(this).hasClass('tablet')){
      $('.demo').removeClass('mobile').removeClass('desktop').addClass('tablet');
    }else{
      $('.demo').removeClass('mobile').removeClass('tablet').addClass('desktop');
    }
    $('.device').removeClass('active');
    $(this).addClass('active');
  });

});

var mariana = {
  fake : [],
  head : [],
  body : [],
  init : function(json){
      this.fake = json;
      // console.log(this.fake);
  },
  parseDom : function(json){
    for(html of json){
      if (html.tagName == 'html' && html.type == 'element'){
        // console.log(html.children);
        for(child of html.children){
          if (child.type == 'element'){
            // console.log(child);
            switch(child.tagName){
              case "head": this.head = child.children; break;
              case "body": this.body = child.children; break;
            }
          }
        }
      }
    }
  },
  parse : function(json){
    this.parseDom(json);
    var result = {
      head : this.checkFragment(this.head),
      body : this.checkFragment(this.body)
    };
    return result;
  },
  parseVariable : function(string){
    return string.trim().replace("{{$", "").replace("}}", "");
  },
  checkFragment : function(object){
    var out = '';
    // console.log(object);
    for(fragment of object){
      switch(fragment.type){
        case "element": out += this.element(fragment); break;
        case "text": out += this.content(fragment.content,object); break;
        case "comment": out += '<!--'+fragment.content+'-->'; break;
      }
    }
    
    return out;
  },
  content : function(content,obj){
    // console.log(content);
    var myRe = new RegExp(/\{\{\$([\S]*)\}\}/g);
    var stringCheck = content.match(myRe);

    if(stringCheck){
      var keyAttr = this.parseVariable(stringCheck[0]);
      content = content.replace(stringCheck[0],this.fake[keyAttr].default);
      if(this.fake[keyAttr].default == '' && (typeof this.fake[keyAttr].demo !== 'undefined')){
        content = content.replace(stringCheck[0],this.fake[keyAttr].demo);
      }else{
        content = content.replace(stringCheck[0],this.fake[keyAttr].default);
      }

      if(keyAttr !== 'font_family'){
      //  content = '<span id="'+ keyAttr +'">'+ content +'</span>';
      }
    }

    return content.replace(/{{if \$[a-z_]+}}/ig, '').replace(/{{\/if}}/ig, '');
  },
  element : function(obj){
    var voidTags = [
      "!doctype", "area", "base", "br", "col", "command", 
      "embed", "hr", "img", "input", "keygen", "link", 
      "meta", "param", "source", "track", "wbr"
    ];

    if(voidTags.indexOf(obj.tagName) === -1){
      var out = '<'+obj.tagName+mariana.attributes(obj)+'>';
      if(typeof obj.children !== 'undefined'){
        out += mariana.checkFragment(obj.children);
      }
      out += '</'+obj.tagName+'>';
    }else{
      var out = '<'+obj.tagName+mariana.attributes(obj)+'/>';
    }
    
    return out;
  },
  attributes : function(obj){

    var out = [];
    var arraySocial= ['{{$group_social_twitter_link}}','{{$group_social_facebook_link}}','{{$group_social_youtube_link}}','{{$group_social_instagram_link}}','{{$group_social_pinterest_link}}','{{$group_social_googleplus_link}}'];
    // check and change attributes

    for(var attribute in obj.attributes){
      if (obj.attributes[attribute]['value'] === null){
        obj.attributes[attribute]['value'] = '';
        continue;
      }else{
        var myRe = new RegExp(/\{\{\$([\S]*)\}\}/g);
        var stringCheck = obj.attributes[attribute]['value'].match(myRe);

        // check has variable
        if(stringCheck){
          var arrayStyle = obj.attributes[attribute]['value'].split(";");
          for(var style in arrayStyle){
            var stringAttr = arrayStyle[style].match(myRe);
            if(stringAttr){
              if(stringAttr.length == 1){
                var keyAttr = this.parseVariable(stringAttr[0]);

                //replace data
                if(keyAttr == 'mails_img_url'){
                  obj.attributes[attribute]['value'] = obj.attributes[attribute]['value'].replace(stringAttr[0],mails_img_url);
                }else{
                  if(this.fake[keyAttr].default == '' && (typeof this.fake[keyAttr].demo !== 'undefined')){
                    obj.attributes[attribute]['value'] = obj.attributes[attribute]['value'].replace(stringAttr[0],this.fake[keyAttr].demo);
                  }else{
                    obj.attributes[attribute]['value'] = obj.attributes[attribute]['value'].replace(stringAttr[0],this.fake[keyAttr].default);
                  }
                }

                // add attribute to select element
                if (arraySocial.indexOf(stringAttr[0]) >= 0) {
                  var objectNew = {
                    'key' : "data-" + keyAttr,
                    'value' : (this.fake[keyAttr].default !== '') ? 'on' : 'off'
                  }
                  obj.attributes.push(objectNew);
                }else{
                  var nameStyle = arrayStyle[style].split(":");
                  if(nameStyle.length > 1){
                    var attrName = nameStyle[0].trim();
                    var attrValue = nameStyle[1].trim();
                    if(nameStyle.length > 1 && obj.tagName !== 'link'){
                      var objectNew = {
                        'key' : "data-" + keyAttr,
                        'value' : attrName
                      }
                      if(attrName == 'background'){
                        var regBgUrl = new RegExp(/url\(\{\{\$([\S]*)\}\}\)/g);
                        var bgUrlCheck = nameStyle[1].trim().match(regBgUrl);
                        if(bgUrlCheck){
                          objectNew = {
                            'key' : "data-" + keyAttr,
                            'value' : 'background-image'
                          }
                        }
                      }
                      if(attrValue.match('border_color')){
                        objectNew = {
                          'key' : "data-" + keyAttr,
                          'value' : 'border-color'
                        }
                      }
                      obj.attributes.push(objectNew);
                    }
                  }else if(nameStyle.length == 1 && obj.tagName !== 'link'){
                    var attrName = obj.attributes[attribute]['key'].trim();
                    var attrValue = obj.attributes[attribute]['value'].trim();
                    var objectNew = {
                      'key' : "data-" + keyAttr,
                      'value' : attrName
                    }                  
                    obj.attributes.push(objectNew);
                  }else if(stringAttr[0].indexOf(':') !== -1){
                    console.log('New case exception (1): ' + nameStyle);
                  }
                }
              }else if(stringAttr.length > 1){
                //replace data
                for(var attr in stringAttr){
                  var keyAttr = this.parseVariable(stringAttr[attr]);
                  if(this.fake[keyAttr].default == '' && (typeof this.fake[keyAttr].demo !== 'undefined')){
                    obj.attributes[attribute]['value'] = obj.attributes[attribute]['value'].replace(stringAttr[attr],this.fake[keyAttr].demo);
                  }else{
                    obj.attributes[attribute]['value'] = obj.attributes[attribute]['value'].replace(stringAttr[attr],this.fake[keyAttr].default);
                  }
                }
                var nameStyle = arrayStyle[style].split(":");
                if(nameStyle[name] = 'background' && stringAttr.length == 2){
                  // add attribute to select element
                  var objectBackgroundColor = {
                    'key' : "data-" + this.parseVariable(stringAttr[0]),
                    'value' : "background-color"
                  }
                  var objectBackgroundUrl = {
                    'key' : "data-" + this.parseVariable(stringAttr[1]),
                    'value' : "background-image"
                  }
                  obj.attributes.push(objectBackgroundColor,objectBackgroundUrl);
                }else{
                  console.log('New case exception (2): ' + stringAttr);
                }
              }else {
                console.log('New case exception (3): ' + stringAttr);
              }
            }
          }
        }else{
          // console.log(stringCheck);
        }
      }
    }

    // write attribute
    for(var attribute in obj.attributes){
      out[attribute] = obj.attributes[attribute]['key']+'="'+obj.attributes[attribute]['value']+'"'; 
    }

    return out.length !== 0 ? ' '+out.join(' ') : '';
  }
};
