{extends file=$layout}

{block name='header'}{/block}

{block name='left_column'}{/block}
{block name='right_column'}{/block}

{block name="content_wrapper"}
  <div id="content-wrapper">
    <section id="main-email">
			<div class="left-sidebar">
        {if $path_file}
          <a href="javascript:void(0);" class="icon-close"><i class="material-icons">close</i></a>
          <div class="select-template">
            <label>Template: </label>
              <span class="select">
        				<select id="select_template">
          					{foreach $path_file as $value}
          					   <option value="{$value}">{$value}</option>
          					{/foreach}
        				</select>
              </span>
              <span class="select">
                <select id="lang">
                  <option value="en">en</option>
                  <option value="de">de</option>
                  <option value="ar">ar</option>
                  <option value="es">es</option>
                  <option value="fr">fr</option>
                  <option value="it">it</option>
                </select>
              </span>
          </div>

          <div class="configuration">
            <div class="responsive">
              <a href="javascript:void(0)" title="Mobile Device" class="mobile device">
                <i class="material-icons">phone_iphone</i>
                <span>Mobile</span>
              </a>
              <a href="javascript:void(0)" title="Tablet Device" class="tablet device">
                <i class="material-icons">tablet_mac</i>
                <span>Tablet</span>
              </a>
              <a href="javascript:void(0)" title="Desktop Device" class="desktop device active">
                <i class="material-icons">desktop_mac</i>
                <span>Desktop</span>
              </a>
            </div>
            <div class="reset-btn">
              <a href="javascript:void(0)" title="Reset Configuration" class="btn btn-primary btn-sm reset" onclick="resetConfiguration()">Reset</a>
            </div>
            <div class="save-template-btn">
              <a href="javascript:void(0)" title="Save Template Email" class="btn btn-primary btn-sm save-email-tem" onclick="saveEmailTemplate()">Save</a>
            </div>  
          </div>
          
          {if isset($config_sidebar) && $config_sidebar}
            <div id="accordion">
              {foreach $config_sidebar as $key => $value}
                {if $key == 'general'}
                  {assign var="group_name" value="General"}
                {elseif $key == 'header'}
                  {assign var="group_name" value="Header"}
                {elseif $key == 'content'}
                  {assign var="group_name" value="Content"}
                {elseif $key == 'footer'}
                  {assign var="group_name" value="Footer"}
                {elseif $key == 'social'}
                  {assign var="group_name" value="Social"}
                {/if}
                {include file="module:leo_emailsmanager/views/templates/front/sidebar_accordion.tpl" group_name=$group_name config=$value key=$key}
              {/foreach}
            </div>
          {/if}
        {else}
          <p class="alert alert-danger">Not exist Template</p>
        {/if}
			</div>

			<div class="right-content">
        <div class="demo">
          <iframe class="view"></iframe>
        </div>
			</div>
      <div class="overlay"></div>
      <a href="javascript:void(0);" class="icon-close"><i class="material-icons">close</i></a>
      <a href="javascript:void(0);" class="icon-setting"><i class="material-icons">settings</i></a>
    	<input type="hidden" name="" value="{if $url} {$url} {/if}" id="url">

    </section>
  </div>
{/block}

{block name='footer'}

{/block}