{strip}
{if $config}
  <div class="card">
    <div class="card-header" id="{$key}_accordion" data-toggle="collapse" data-target="#collapse{$key}" aria-controls="collapse{$key}" {if $key == 'general'}aria-expanded="true"{/if}>
      <span class="card-header-name">{$group_name}</span>
      <i class="icon-collapse" data-toggle="collapse" data-target="#collapse{$key}" aria-controls="collapse{$key}" {if $key == 'general'}aria-expanded="true"{/if}></i>
    </div>
    <div id="collapse{$key}" class="collapse {if $key == 'general'}in{/if}" aria-labelledby="{$key}_accordion" data-parent="#accordion" {if $key == 'general'}aria-expanded="true"{/if}>
      <div class="card-body">
        <ul class="setttings">
          {foreach $config as $key => $value}
            <li>
              <span class="label-title text_{$key}">{$value['label']['en']}</span>
              <span class="content-input">
                <span class="alert-input">
                  <i class="material-icons">cancel</i>
                  <span class="alert-content"></span>
                </span>
                {if $value['type'] == "color"}
                  <input type="text" name="{$value['name']}" data-default="{$value['default']}" value="{$value['default']}" class="input jscolor { position:'top', onFineChange:'update(this)', value:'{$value['default']}', setIn: '{$value["name"]}', hash:true }" data-source="{$value['datasource']}" data-action="{$value['dataaction']}">
                {elseif $value['type'] == "radio"}
                  <div class="radio-group">
                    <input type="checkbox" name="{$value['name']}" data-default="{if $value['default'] !== ''}checked{/if}"value="{$value['default']}" class="input radio" {if $value['default'] !== ''}checked="checked{/if}">
                    <div class="radio-element"></div>
                  </div>
                {elseif $value['type'] === "text-input"}
                  <textarea name="{$value['name']}" rows="5" data-default="{if $value['default']|@count > 1}{$value['default']['en'] nofilter}{else}{$value['default'] nofilter}{/if}" class="input text text-input">{if $value['default']|@count > 1}{$value['default']['en'] nofilter}{else}{$value['default'] nofilter}{/if}</textarea>
                {else}
                  <input type="text" name="{$value['name']}" class="input text {if $value['type'] === 'font-family'}font-family{/if}" 
                    data-default="
                    {if $value['default']|@count > 1}
                      {if isset($value['demo']) && $value['default']['en'] == ''}
                        {$value['demo']}
                      {else}
                        {$value['default']['en']}
                      {/if}
                    {else}
                      {if isset($value['demo']) && $value['default'] == ''}
                        {$value['demo']}
                      {else}
                        {$value['default']}
                      {/if}
                    {/if}" 
                    value="
                    {if $value['default']|@count > 1}
                      {if isset($value['demo']) && $value['default']['en'] == ''}
                        {$value['demo']}
                      {else}
                        {$value['default']['en']}
                      {/if}
                    {else}
                      {if isset($value['demo']) && $value['default'] == ''}
                        {$value['demo']}
                      {else}
                        {$value['default']}
                      {/if}
                    {/if}" 
                    data-source="{$value['datasource']}" data-action="{$value['dataaction']}"
                  > 
                {/if}
                {if ($value['desc']['en'] !== '' && $value['type'] !== "radio")}
                  <span class="desc">{$value['desc']['en'] nofilter}</span>
                {/if}
              </span>
            </li>
          {/foreach}
        </ul>
      </div>
    </div>
  </div>
{/if}
{/strip}

{* {if $value['default']|@count > 1}
  {$value['default']['en']}
{else}
  {if $value['default'] == '' && isset($value['demo'])}
    {$value['demo']}
  {else}
    {$value['default']}
  {/if}
{/if} *}

{* <pre>
  {print_r($config)}
</pre> *}